#ifndef __X10_IO_FILTERWRITER_H
#define __X10_IO_FILTERWRITER_H

#include <x10rt.h>


#define X10_IO_WRITER_H_NODEPS
#include <x10/io/Writer.h>
#undef X10_IO_WRITER_H_NODEPS
namespace x10 { namespace lang { 
class Byte;
} } 
namespace x10 { namespace io { 

class FilterWriter : public x10::io::Writer   {
    public:
    RTT_H_DECLS_CLASS
    
    using x10::io::Writer::write;
    
    x10aux::ref<x10::io::Writer> FMGL(w);
    
    virtual x10aux::ref<x10::io::Writer> inner();
    void _constructor(x10aux::ref<x10::io::Writer> w);
    
    static x10aux::ref<x10::io::FilterWriter> _make(x10aux::ref<x10::io::Writer> w);
    
    virtual void close();
    virtual void flush();
    virtual void write(x10_byte b);
    virtual x10aux::ref<x10::io::FilterWriter> x10__io__FilterWriter____x10__io__FilterWriter__this(
      );
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_IO_FILTERWRITER_H

namespace x10 { namespace io { 
class FilterWriter;
} } 

#ifndef X10_IO_FILTERWRITER_H_NODEPS
#define X10_IO_FILTERWRITER_H_NODEPS
#ifndef X10_IO_FILTERWRITER_H_GENERICS
#define X10_IO_FILTERWRITER_H_GENERICS
#endif // X10_IO_FILTERWRITER_H_GENERICS
#endif // __X10_IO_FILTERWRITER_H_NODEPS
